VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   4680
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4680
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' See Eric W. Weisstein's article "Newton's Method."
' From MathWorld--A Wolfram Web Resource.
' http://mathworld.wolfram.com/NewtonsMethod.html

Option Explicit

Private Sub Form_Load()
    Height = 5 * 1440 + (Height - ScaleHeight)
    Width = 5 * 1440 + (Width - ScaleWidth)

    Me.Scale (-10, 10)-(10, -10)
End Sub


' The function.
Private Function F(ByVal X As Double) As Single
    F = X * X * X / 3 - 2 * X * X + 5
End Function

' The function's derivative.
Private Function dFdx(ByVal X As Double) As Single
    dFdx = X * X - 4 * X
End Function

' Find the roots by using Newton's method.
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Const CUTOFF As Single = 0.0000001
Dim epsilon As Single
Dim iterations As Integer
Dim x0 As Single

    ' Clear previous results.
    DrawGraph

    x0 = X
    iterations = 0
    Do
        iterations = iterations + 1
        Me.Line (x0, -1.5)-Step(0, 3)
        epsilon = -F(x0) / dFdx(x0)
        x0 = x0 + epsilon
    Loop While Abs(epsilon) > CUTOFF
    Me.Line (x0, -3)-Step(0, 6)

    Me.Caption = x0 & " +/-" & epsilon & " in " & iterations & " iterations"
End Sub

Private Sub Form_Paint()
    DrawGraph
End Sub
' Draw the background graph.
Private Sub DrawGraph()
Const STEP_SIZE As Single = 0.1
Dim X As Single
Dim Y As Single
Dim y1 As Single
Dim y2 As Single

    Me.Cls

    ' Draw the axes.
    For X = -10 To 10
        Me.Line (X, -0.5)-Step(0, 1), vbBlue
    Next X
    For Y = -10 To 10
        Me.Line (-0.5, Y)-Step(1, 0), vbBlue
    Next Y
    Me.Line (-10, 0)-Step(20, 0), vbBlue
    Me.Line (0, -10)-Step(0, 20), vbBlue

    ' Draw the curve.
    y2 = F(-10)
    For X = -10 + STEP_SIZE To 10 Step STEP_SIZE
        y1 = y2
        y2 = F(X)
        Me.Line (X - STEP_SIZE, y1)-(X, y2), vbRed
    Next X
End Sub


